"""Remove duplicated log entries keeping only most recent unique user messages

Reason:
    This migration was created to avoid many entries of the same text in the
    database. N

Revision ID: 213f246e1490
Revises: 45546b047abe

"""
from alembic import op
import sqlalchemy as sa
from rasax.community.database.conversation import MessageLog

# revision identifiers, used by Alembic.
revision = "213f246e1490"
down_revision = "45546b047abe"
branch_labels = None
depends_on = None


def upgrade():
    bind = op.get_bind()
    session = sa.orm.Session(bind=bind)
    message_logs = session.query(MessageLog)

    unique_logs_hash = {}

    for log in message_logs:
        if log.hash in unique_logs_hash:
            # delete older log
            session.delete(unique_logs_hash[log.hash])
        unique_logs_hash[log.hash] = log

    session.commit()
